/* -*- c-basic-offset: 4; -*- */

#ifndef RegistryHH
#define RegistryHH

#include "genericAPI/config.h"

#include "general/undef_ac.h"
#if HAVE_LIBOSPACE
#include <ospace/network.h>
#endif /* HAVE_LIBOSPACE */

#include <general/objectregistry.hh>

#if HAVE_LDAS_PACKAGE_ILWD
#include "ilwd/ldaselement.hh"
#endif /* HAVE_LDAS_PACKAGE_ILWD */

#include "genericAPI/LdasBinary.hh"
#include "file.hh"

namespace Registry
{    
#if HAVE_LDAS_PACKAGE_ILWD
    class ElementRegistry_type
	: public ObjectRegistry< ILwd::LdasElement >
    {
    public:

	bool contentsSearch( const ILwd::LdasElement* Element ) const;
	std::string getElementList( ) const;

    };
#endif /* HAVE_LDAS_PACKAGE_ILWD */

    class BinaryRegistry_type
	: public ObjectRegistry< LdasBinary >
    {
    };

#if HAVE_LIBOSPACE
    class ServerRegistry_type
	: public ObjectRegistry< os_tcp_connection_server >
    {
    };
#endif /* HAVE_LIBOSPACE */

#if HAVE_LDAS_PACKAGE_ILWD
    extern ElementRegistry_type elementRegistry;
#endif /* HAVE_LDAS_PACKAGE_ILWD */
    extern BinaryRegistry_type binaryRegistry;
#if HAVE_LIBOSPACE
    extern ServerRegistry_type serverRegistry;
    extern ObjectRegistry< os_tcp_socket > activeSocketRegistry;
    extern ObjectRegistry< os_tcp_socket > passiveSocketRegistry;
#endif /* HAVE_LIBOSPACE */

#if HAVE_LDAS_PACKAGE_ILWD
    bool isElementValid( const ILwd::LdasElement* element ) throw();
#endif /* HAVE_LDAS_PACKAGE_ILWD */
    bool isBinaryValid( const LdasBinary* binary ) throw();
#if HAVE_LIBOSPACE
    bool isServerValid( const os_tcp_connection_server* server ) throw();
    bool isSocketValid( const os_tcp_socket* socket ) throw();
#endif /* HAVE_LIBOSPACE */
}


#endif // RegistryHH
